package org.bitbucket.bradleysmithllc.etlunit;

import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestMethod;

import java.util.Map;

public interface TestResultMetrics
{
	int getNumberOfTestsRun();

	int getNumberOfTestsPassed();

	int getNumberOfAssertionFailures();

	int getNumberOfWarnings();

	int getNumberOfErrors();

	void addStatus(ETLTestMethod method, StatusReporter.CompletionStatus status);

	void addTestsPassed(int num);

	void addAssertionFailures(int num);

	void addTestWarnings(int num);

	void addErrors(int num);

	void reset();

	Map<String, StatusReporter.CompletionStatus> getResultsMapByTest();
}