package org.bitbucket.bradleysmithllc.etlunit;

import java.util.ArrayList;
import java.util.List;

public class TestResultsImpl implements TestResults
{
	private final List<TestClassResult> results = new ArrayList<TestClassResult>();
	private final TestResultMetrics testResultMetrics = new TestResultMetricsImpl();
	private final int numTestsSelected;

	public TestResultsImpl(int numTestsSelected)
	{
		this.numTestsSelected = numTestsSelected;
	}

	@Override
	public TestResultMetrics getMetrics()
	{
		return testResultMetrics;
	}

	@Override
	public List<TestClassResult> getResultsByClass()
	{
		return results;
	}

	@Override
	public void reset()
	{
		results.clear();
		testResultMetrics.reset();
	}

	@Override
	public int getNumTestsSelected()
	{
		return numTestsSelected;
	}
}