package org.bitbucket.bradleysmithllc.etlunit.feature.debug;

import com.google.inject.Injector;
import org.bitbucket.bradleysmithllc.etlunit.StatusReporter;
import org.bitbucket.bradleysmithllc.etlunit.feature.AbstractFeature;
import org.bitbucket.bradleysmithllc.etlunit.feature.FeatureModule;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

@FeatureModule
public class ConsoleFeatureModule extends AbstractFeature
{
	private static final List<String> prerequisites = new ArrayList<String>(Arrays.asList("results"));

	private final ConsoleStatusReporter consoleStatusReporter = new ConsoleStatusReporter();

	@Override
	public List<String> getPrerequisites()
	{
		return prerequisites;
	}

	@Override
	public void initialize(Injector inj)
	{
		inj.injectMembers(consoleStatusReporter);
	}

	public ConsoleStatusReporter getConsoleStatusReporter()
	{
		return consoleStatusReporter;
	}

	@Override
	public StatusReporter getStatusReporter()
	{
		return consoleStatusReporter;
	}

	@Override
	public String getFeatureName()
	{
		return "console";
	}

	@Override
	public boolean requiredForSimulation() {
		return true;
	}
}