package org.bitbucket.bradleysmithllc.etlunit.feature.debug;

import org.bitbucket.bradleysmithllc.etlunit.ClassDirector;
import org.bitbucket.bradleysmithllc.etlunit.NullClassDirector;
import org.bitbucket.bradleysmithllc.etlunit.feature.AbstractFeature;
import org.bitbucket.bradleysmithllc.etlunit.feature.FeatureModule;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestClass;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestMethod;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestOperation;

@FeatureModule
public class RunAllFeatureModule extends AbstractFeature
{

	private final ClassDirector nullClassDirector = new NullClassDirector()
	{
		@Override
		public response_code accept(ETLTestClass cl)
		{
			return response_code.accept;
		}

		@Override
		public response_code accept(ETLTestOperation op)
		{
			return response_code.accept;
		}

		@Override
		public response_code accept(ETLTestMethod mt)
		{
			return response_code.accept;
		}
	};

	@Override
	public ClassDirector getDirector()
	{
		return nullClassDirector;
	}

	public String getFeatureName()
	{
		return "run-all-director";
	}

	@Override
	public boolean requiredForSimulation() {
		return true;
	}
}