package org.bitbucket.bradleysmithllc.etlunit.metadata;

import org.bitbucket.bradleysmithllc.etlunit.io.JsonSerializable;

import java.io.File;
import java.io.IOException;
import java.util.List;
import java.util.Map;

public interface MetaDataPackageContext extends JsonSerializable
{
	Map<String, MetaDataArtifact> getArtifactMap();

	enum path_type {
		feature_source,
		test_source,
		external_source
	}

	String getPackageName();
	path_type getPathType();
	List<MetaDataArtifact> getArtifacts();
	MetaDataArtifact createArtifact(String relative, File path) throws IOException;
	MetaDataArtifact createArtifact(String relative, String projectRelative, File path);
}